searchData={"items":[{"type":"module","title":"Rein","doc":"Reinforcement Learning training and inference framework","ref":"Rein.html"},{"type":"function","title":"Rein.train/5","doc":"","ref":"Rein.html#train/5"},{"type":"type","title":"Rein.t/0","doc":"","ref":"Rein.html#t:t/0"},{"type":"behaviour","title":"Rein.Agent","doc":"The behaviour that should be implemented by a `Rein` agent module.","ref":"Rein.Agent.html"},{"type":"callback","title":"Rein.Agent.init/2","doc":"Initializes the agent state with the given agent-specific options.\n\nShould be implemented in a way that the result would be semantically\nthe same as if `c:reset/2` was called in the end of the function.\n\nAs a suggestion, the implementation should only initialize fixed\nvalues here, that is values that don't change between sessions\n(epochs for non-episodic tasks, episodes for episodic tasks). Then,\ncall `c:reset/2` internally to initialize the rest of variable values.","ref":"Rein.Agent.html#c:init/2"},{"type":"callback","title":"Rein.Agent.optimize_model/1","doc":"","ref":"Rein.Agent.html#c:optimize_model/1"},{"type":"callback","title":"Rein.Agent.record_observation/5","doc":"Can be used to record the observation in an experience replay buffer.\n\nIf this is not desired, just make this function return the first argument unchanged.","ref":"Rein.Agent.html#c:record_observation/5"},{"type":"callback","title":"Rein.Agent.reset/2","doc":"Resets any values that vary between sessions (which would be episodes\nfor episodic tasks) for the agent state.","ref":"Rein.Agent.html#c:reset/2"},{"type":"callback","title":"Rein.Agent.select_action/2","doc":"Selects the action to be taken.","ref":"Rein.Agent.html#c:select_action/2"},{"type":"type","title":"Rein.Agent.rl_state/0","doc":"The full state of the current Reinforcement Learning process, as stored in the `Rein` struct","ref":"Rein.Agent.html#t:rl_state/0"},{"type":"type","title":"Rein.Agent.t/0","doc":"An arbitrary `Nx.Container` that holds metadata for the agent","ref":"Rein.Agent.html#t:t/0"},{"type":"behaviour","title":"Rein.Environment","doc":"Defines an environment to be passed to `Rein`.","ref":"Rein.Environment.html"},{"type":"callback","title":"Rein.Environment.apply_action/2","doc":"Applies the selected action to the environment.\n\nReturns the updated environment, also updated with the reward\nand a flag indicating whether the new state is terminal.","ref":"Rein.Environment.html#c:apply_action/2"},{"type":"callback","title":"Rein.Environment.init/2","doc":"Initializes the environment state with the given enviroment-specific options.\n\nShould be implemented in a way that the result would be semantically\nthe same as if `c:reset/2` was called in the end of the function.\n\nAs a suggestion, the implementation should only initialize fixed\nvalues here, that is values that don't change between sessions\n(epochs for non-episodic tasks, episodes for episodic tasks). Then,\ncall `c:reset/2` internally to initialize the rest of variable values.","ref":"Rein.Environment.html#c:init/2"},{"type":"callback","title":"Rein.Environment.reset/2","doc":"Resets any values that vary between sessions (which would be episodes\nfor episodic tasks, epochs for non-episodic tasks) for the environment state.","ref":"Rein.Environment.html#c:reset/2"},{"type":"type","title":"Rein.Environment.rl_state/0","doc":"The full state of the current Reinforcement Learning process, as stored in the `Rein` struct","ref":"Rein.Environment.html#t:rl_state/0"},{"type":"type","title":"Rein.Environment.t/0","doc":"An arbitrary `Nx.Container` that holds metadata for the environment","ref":"Rein.Environment.html#t:t/0"},{"type":"module","title":"Rein.Agents.DDPG","doc":"Deep Deterministic Policy Gradient implementation.\n\nThis assumes that the Actor network will output `{nil, num_actions}` actions,\nand that the Critic network accepts the `\"actions\"` input with the same shape.\n\nActions are deemed to be in a continuous space of type `:f32`.","ref":"Rein.Agents.DDPG.html"},{"type":"function","title":"Rein.Agents.DDPG.update_priorities/3","doc":"","ref":"Rein.Agents.DDPG.html#update_priorities/3"},{"type":"module","title":"Rein.Agents.DQN","doc":"Deep Q-Learning implementation.\n\nThis implementation utilizes a single target network for\nthe policy network.","ref":"Rein.Agents.DQN.html"},{"type":"function","title":"Rein.Agents.DQN.update_priorities/4","doc":"","ref":"Rein.Agents.DQN.html#update_priorities/4"},{"type":"module","title":"Rein.Agents.QLearning","doc":"Q-Learning implementation.\n\nThis implementation uses epsilon-greedy sampling\nfor exploration, and doesn't contemplate any kind\nof target network.","ref":"Rein.Agents.QLearning.html"},{"type":"module","title":"Rein.Agents.SAC","doc":"Soft Actor-Critic implementation.\n\nThis assumes that the Actor network will output `{nil, num_actions, 2}`,\nwhere for each action they output the $\\mu$ and $\\sigma$ values of a random\nnormal distribution, and that the Critic network accepts `\"actions\"` input with\nshape `{nil, num_actions}`, where the action is calculated by sampling from\nsaid random distribution.\n\nActions are deemed to be in a continuous space of type `:f32`.\n\nThe Dual Q implementation utilizes two copies of the critic network, `critic1` and `critic2`,\neach with their own separate target network.\n\nVectorized axes from `:random_key` are propagated normally throughout\nthe agent state for parallel simulations, but all samples are stored in the same\ncircular buffer. After all simulations have ran, the optimization steps are run\non a sample space consisting of all previous experiences, including all of the\nparallel simulations that have just finished executing.","ref":"Rein.Agents.SAC.html"},{"type":"module","title":"Rein.Environments.Gridworld","doc":"Gridworld environment with 4 discrete actions.\n\nGridworld is an environment where the agent\naims to reach a given target from a collection\nof possible targets, only being able to choose\n1 of 4 actions: up, down, left and right.","ref":"Rein.Environments.Gridworld.html"},{"type":"function","title":"Rein.Environments.Gridworld.as_state_vector/1","doc":"Default function for turning the environment into a vector representation.","ref":"Rein.Environments.Gridworld.html#as_state_vector/1"},{"type":"function","title":"Rein.Environments.Gridworld.bounding_box/0","doc":"","ref":"Rein.Environments.Gridworld.html#bounding_box/0"},{"type":"function","title":"Rein.Environments.Gridworld.num_actions/0","doc":"","ref":"Rein.Environments.Gridworld.html#num_actions/0"},{"type":"function","title":"Rein.Environments.Gridworld.state_vector_size/0","doc":"The size of the state vector returned by `as_state_vector/1`","ref":"Rein.Environments.Gridworld.html#state_vector_size/0"},{"type":"module","title":"Rein.Utils.CircularBuffer","doc":"Circular Buffer utility via Nx Containers.","ref":"Rein.Utils.CircularBuffer.html"},{"type":"function","title":"Rein.Utils.CircularBuffer.append/2","doc":"Append an item to the current buffer.\n\nIf the `buffer` data has shape `{a, b, c, ...}`,\n`item` must have shape `{b, c, ...}`","ref":"Rein.Utils.CircularBuffer.html#append/2"},{"type":"function","title":"Rein.Utils.CircularBuffer.append_multiple/2","doc":"Append multiple items to the buffer.\n\nWorks in a similar fashion to `append/2`, but receives\na tensor with shape equal to the buffer data except\nfor the first axis, which will be the number of items to be appended.","ref":"Rein.Utils.CircularBuffer.html#append_multiple/2"},{"type":"function","title":"Rein.Utils.CircularBuffer.new/2","doc":"Creates a new `Elixir.Rein.Utils.CircularBuffer` with a given shape.","ref":"Rein.Utils.CircularBuffer.html#new/2"},{"type":"function","title":"Options - Rein.Utils.CircularBuffer.new/2","doc":"* `:init_value` - a number or tensor that will be broadcasted\n    to `shape`. Defaults to `0`. If the value given is vectorized,\n    the buffer will be vectorized accordingly, but all entries will\n    share the same current index and size.\n\n  * `:type` - the type for the tensor if `:init_value`.\n    Defaults to `:f32`","ref":"Rein.Utils.CircularBuffer.html#new/2-options"},{"type":"function","title":"Rein.Utils.CircularBuffer.ordered_data/1","doc":"Returns the data starting at the current index.\n\nThe oldest persisted entry will be the first entry in\nthe result, and so on.","ref":"Rein.Utils.CircularBuffer.html#ordered_data/1"},{"type":"module","title":"Rein.Utils.Noise.OUProcess","doc":"Ornstein-Uhlenbeck (OU for short) noise generator\nfor temporally correlated noise.","ref":"Rein.Utils.Noise.OUProcess.html"},{"type":"function","title":"Rein.Utils.Noise.OUProcess.init/2","doc":"Initializes the `Elixir.Rein.Utils.Noise.OUProcess`.","ref":"Rein.Utils.Noise.OUProcess.html#init/2"},{"type":"function","title":"Options - Rein.Utils.Noise.OUProcess.init/2","doc":"* `:theta` - the temperature parameter. Defaults to `0.15`.\n  * `:sigma` - the standard deviation parameter. Defaults to `0.2`.\n  * `:mu` - the initial mean for the distribution. Defaults to `0`.\n  * `:type` - the output type for the samples. Should be floating point.\n    Defaults to `:f32`.","ref":"Rein.Utils.Noise.OUProcess.html#init/2-options"},{"type":"function","title":"Rein.Utils.Noise.OUProcess.reset/1","doc":"Resets the process to the initial value.","ref":"Rein.Utils.Noise.OUProcess.html#reset/1"},{"type":"function","title":"Rein.Utils.Noise.OUProcess.sample/2","doc":"Samples the process and returns the updated `state` and the updated `random_key`.\n\nThe new sample is contained within `state.x`.","ref":"Rein.Utils.Noise.OUProcess.html#sample/2"},{"type":"extras","title":"First steps with Gridworld","doc":"# First steps with Gridworld\n\n```elixir\nmy_app_root = Path.join(__DIR__, \"..\")\n\nMix.install(\n  [\n    {:rein, path: my_app_root},\n    {:kino_vega_lite, \"~> 0.1\"}\n  ],\n  config_path: Path.join(my_app_root, \"config/config.exs\"),\n  lockfile: Path.join(my_app_root, \"mix.lock\"),\n  # change to \"cuda118\" or \"cuda120\" to use CUDA\n  system_env: %{\"XLA_TARGET\" => \"cpu\"}\n)\n```","ref":"gridworld.html"},{"type":"extras","title":"Initializing the plot - First steps with Gridworld","doc":"In the code block below, we initialize some meta variables and configure our VegaLite plot in way that it can be updated iteratively over the algorithm iterations.\n\n```elixir\nalias VegaLite, as: Vl\n\n{min_x, max_x, min_y, max_y} = Rein.Environments.Gridworld.bounding_box()\n\npossible_targets_l = [[round((min_x + max_x) / 2), max_y]]\n\n# possible_targets_l =\n#   for x   Vl.layers([\n    Vl.new()\n    |> Vl.data(name: \"target\")\n    |> Vl.mark(:point,\n      fill: true,\n      tooltip: [content: \"data\"],\n      grid: true,\n      size: [expr: \"height * 4 * #{:math.pi()} / #{max_y - min_y}\"]\n    )\n    |> Vl.encode_field(:x, \"x\", type: :quantitative)\n    |> Vl.encode_field(:y, \"y\", type: :quantitative)\n    |> Vl.encode_field(:color, \"episode\",\n      type: :nominal,\n      scale: [scheme: \"blues\"],\n      legend: false\n    ),\n    Vl.new()\n    |> Vl.data(name: \"trajectory\")\n    |> Vl.mark(:line, point: true, opacity: 1, tooltip: [content: \"data\"])\n    |> Vl.encode_field(:x, \"x\", type: :quantitative, scale: [domain: [min_x, max_x], clamp: true])\n    |> Vl.encode_field(:y, \"y\", type: :quantitative, scale: [domain: [min_y, max_y], clamp: true])\n    |> Vl.encode_field(:order, \"index\")\n  ])\n  |> Kino.VegaLite.new()\n  |> Kino.render()\n\nnil\n```","ref":"gridworld.html#initializing-the-plot"},{"type":"extras","title":"Configuring and running the Q Learning Agent - First steps with Gridworld","doc":"Now we're ready to start configuring our agent. The `plot_fn` function defined below is a callback that `Rein` calls at the end of each iteration, so that we can do anything with the data.\n\nUsually, this means that we'll extract data to either plot, report or save somewhere.\n\n```elixir\n# 250 max_iter * 15 episodes\nmax_points = 1000\n\nplot_fn = fn axon_state ->\n  if axon_state.iteration > 1 do\n    episode = axon_state.epoch\n\n    Kino.VegaLite.clear(grid_widget, dataset: \"target\")\n    Kino.VegaLite.clear(grid_widget, dataset: \"trajectory\")\n\n    Kino.VegaLite.push(\n      grid_widget,\n      %{\n        x: Nx.to_number(axon_state.step_state.environment_state.target_x),\n        y: Nx.to_number(axon_state.step_state.environment_state.target_y)\n      },\n      dataset: \"target\"\n    )\n\n    IO.inspect(\"Episode #{episode} ended\")\n\n    trajectory = axon_state.step_state.trajectory\n\n    iteration = Nx.to_number(axon_state.step_state.iteration)\n\n    points =\n      trajectory[0..(iteration - 1)//1]\n      |> Nx.to_list()\n      |> Enum.with_index(fn [x, y], index ->\n        %{\n          x: x,\n          y: y,\n          index: index\n        }\n      end)\n\n    Kino.VegaLite.push_many(grid_widget, points, dataset: \"trajectory\")\n  end\n\n  axon_state\nend\n```\n\nNow, we get to the actual training!\n\nThe code below calls `Rein.train` with some configuration for the `Gridworld` environment being solved through a `QLearning` agent.\n\nThis will return the whole `Axon.Loop` struct in the `result` variable, so that we can inspect and/or save it afterwards.\n\n```elixir\nKino.VegaLite.clear(grid_widget)\n\nepisodes = 15_000\nmax_iter = 20\n\nenvironment_to_state_vector_fn = fn %{x: x, y: y, target_x: target_x, target_y: target_y} ->\n  delta_x = Nx.subtract(x, min_x)\n  delta_y = Nx.subtract(y, min_y)\n\n  Nx.stack([delta_x, delta_y, Nx.subtract(target_x, min_x), Nx.subtract(target_y, min_y)])\nend\n\nstate_to_trajectory_fn = fn %{environment_state: %{x: x, y: y}} ->\n  Nx.stack([x, y])\nend\n\ndelta_x = max_x - min_x + 1\ndelta_y = max_y - min_y + 1\n\nstate_space_shape = {delta_x, delta_y, delta_x, delta_y}\n\n{t, result} =\n  :timer.tc(fn ->\n    Rein.train(\n      {Rein.Environments.Gridworld, possible_targets: possible_targets},\n      {Rein.Agents.QLearning,\n       state_space_shape: state_space_shape,\n       num_actions: 4,\n       environment_to_state_vector_fn: environment_to_state_vector_fn,\n       learning_rate: 1.0e-2,\n       gamma: 0.99,\n       exploration_eps: 1.0e-4},\n      plot_fn,\n      state_to_trajectory_fn,\n      num_episodes: episodes,\n      max_iter: max_iter\n    )\n  end)\n\n\"#{Float.round(t / 1_000_000, 3)} s\"\n```\n\nWith the code below, we can check some points of interest in the learned Q matrix.\n\nEspecially, we can see below that for a target at x = 2, y = 4:\n\n* For the position x = 2, y = 3, the selected action is to go up;\n* For the position x = 1, y = 4, the selected action is to go right;\n* For the position x = 3, y = 4, the selected action is to go left.\n\nThis shows that at least for the positions closer to the target, our agent already knows the best policy for those respective states!\n\n```elixir\nstate_vector_to_index = fn state_vector, shape ->\n  {linear_indices_offsets_list, _} =\n    shape\n    |> Tuple.to_list()\n    |> Enum.reverse()\n    |> Enum.reduce({[], 1}, fn x, {acc, multiplier} ->\n      {[multiplier | acc], multiplier * x}\n    end)\n\n  linear_indices_offsets = Nx.tensor(linear_indices_offsets_list)\n\n  Nx.dot(state_vector, linear_indices_offsets)\nend\n\n# Actions are [up, down, right, left]\n\n# up\nidx = state_vector_to_index.(Nx.tensor([2, 3, 2, 4]), {5, 5, 5, 5})\nIO.inspect(result.step_state.agent_state.q_matrix[idx])\n\n# right\nidx = state_vector_to_index.(Nx.tensor([1, 4, 2, 4]), {5, 5, 5, 5})\nIO.inspect(result.step_state.agent_state.q_matrix[idx])\n\n# left\nidx = state_vector_to_index.(Nx.tensor([3, 4, 2, 4]), {5, 5, 5, 5})\nIO.inspect(result.step_state.agent_state.q_matrix[idx])\n\nnil\n```","ref":"gridworld.html#configuring-and-running-the-q-learning-agent"}],"content_type":"text/markdown"}